package dtu.library.persistency;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.PrintWriter;

import dtu.library.app.Book;
import dtu.library.app.Cd;
import dtu.library.app.LibraryApp;
import dtu.library.app.User;

	public abstract class PersistentObject {

	protected LibraryApp libApp;

	abstract public void storeOn(PrintWriter out);

	abstract public String getKey();

	public void setLibraryApp(LibraryApp libApp) {
		this.libApp = libApp;
	}
	
	abstract protected void readFromReader( PersistencyLayer pl, BufferedReader reader) throws IOException;

	public static PersistentObject read(BufferedReader in,
			PersistencyLayer pl) throws IOException {
		String type = in.readLine();
		PersistentObject po = null;
		if (type.equals("dtu.library.app.User")) {
			po = new User();
		} else if (type.equals("dtu.library.app.Book")) {
			po = new Book();
		} else if (type.equals("dtu.library.app.Cd")) {
			po = new Cd();
		}
		if (po != null) {
			po.readFromReader(pl, in);
		}
		return po;
	}
}
