package dtu.library.persistency;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNull;

import java.util.Calendar;
import java.util.List;

import dtu.library.app.Address;
import dtu.library.app.Medium;
import dtu.library.app.User;


public class Utilities {
	public static void compareUsers(User expected, User actual) {
		assertNotNull(expected.getCprNumber());
		assertEquals(expected.getCprNumber(), actual.getCprNumber());
		assertNotNull(expected.getName());
		assertEquals(expected.getName(), actual.getName());
		assertNotNull(expected.getEmail());
		assertEquals(expected.getEmail(), actual.getEmail());
		Address address1 = actual.getAddress();

		Address address = expected.getAddress();
		compareAddresses(address, address1);

		compareBorrowedBooks(expected.getBorrowedMedia(), actual
				.getBorrowedMedia());
	}

	public static  void compareBorrowedBooks(List<Medium> expected, List<Medium> actual) {
		assertEquals(expected.size(), actual.size());
		for (int i = 0; i < expected.size(); i++) {
			compareMedium(expected.get(i), actual.get(i));
		}
	}

	public static void compareAddresses(Address expected, Address actual) {
		assertNotNull(expected.getStreet());
		assertEquals(expected.getStreet(), actual.getStreet());
		assertNotNull(expected.getPostnumber());
		assertEquals(expected.getPostnumber(), actual.getPostnumber());
		assertNotNull(expected.getTown());
		assertEquals(expected.getTown(), actual.getTown());
	}

	public static void compareMedium(Medium expected, Medium actual) {
		assertNotNull(expected.getSignature());
		assertEquals(expected.getSignature(), actual.getSignature());
		assertNotNull(expected.getAuthor());
		assertEquals(expected.getAuthor(), actual.getAuthor());
		assertNotNull(expected.getTitle());
		assertEquals(expected.getTitle(), actual.getTitle());

		if (expected.getBorrowDate() == null) {
			assertNull(actual.getBorrowDate());
		} else {
			assertEquals(expected.getBorrowDate().get(Calendar.YEAR), actual
					.getBorrowDate().get(Calendar.YEAR));
			assertEquals(expected.getBorrowDate().get(Calendar.DAY_OF_YEAR),
					actual.getBorrowDate().get(Calendar.DAY_OF_YEAR));
		}
	}

}
